{
  "cells": [
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# 14wk-1: 클래스공부 4단계 – 파이썬의 비밀 (2)\n",
        "\n",
        "최규빈  \n",
        "2023-06-05\n",
        "\n",
        "<a href=\"https://colab.research.google.com/github/guebin/PP2023/blob/main/posts/03_Class/2023-06-05-14wk-1.ipynb\"><img src=\"https://colab.research.google.com/assets/colab-badge.svg\" style=\"text-align: left\"></a>\n",
        "\n",
        "# 강의영상\n",
        "\n",
        "> youtube:\n",
        "> <https://youtube.com/playlist?list=PLQqh36zP38-xEFWxQ9YvfTo0wBN4CUZlP>\n",
        "\n",
        "# imports"
      ],
      "id": "c9b53a7e-f2a0-47eb-b447-177b84684970"
    },
    {
      "cell_type": "code",
      "execution_count": 1,
      "metadata": {},
      "outputs": [],
      "source": [
        "import numpy as np\n",
        "import matplotlib.pyplot as plt\n",
        "import pandas as pd"
      ],
      "id": "6835093b-64a4-467c-9f96-ad622c5bef2c"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# 예비학습\n",
        "\n",
        "## 모티브: 클래스를 수정은 불편해\n",
        "\n",
        "`-` 예시1: UpJump ver1"
      ],
      "id": "46cbf3de-2b30-4e79-993f-a6883118ecd3"
    },
    {
      "cell_type": "code",
      "execution_count": 2,
      "metadata": {},
      "outputs": [],
      "source": [
        "class UpJump:\n",
        "    def __init__(self):\n",
        "        self.value = 0\n",
        "    def up(self):\n",
        "        self.value = self.value + 1  \n",
        "    def __repr__(self):\n",
        "        return str(self.value)"
      ],
      "id": "7e049991-6479-4cd8-aeb5-0de9d96d8f71"
    },
    {
      "cell_type": "code",
      "execution_count": 3,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = UpJump()\n",
        "a.up()"
      ],
      "id": "a7f3ede5-94d4-459e-a7cf-1f15d0d4c002"
    },
    {
      "cell_type": "code",
      "execution_count": 6,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "587e516d-0114-4646-92a7-c037fdc45966"
    },
    {
      "cell_type": "code",
      "execution_count": 7,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.jump(2)"
      ],
      "id": "708adca9-6775-4dae-a215-1920189ae095"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   점프는 아직 구현하지 않음.\n",
        "\n",
        "`-` 예시2: UpJump ver2"
      ],
      "id": "fcb22b37-681d-4def-b8e0-4a2345c11e99"
    },
    {
      "cell_type": "code",
      "execution_count": 8,
      "metadata": {},
      "outputs": [],
      "source": [
        "class UpJump_Ver2:\n",
        "    def __init__(self):\n",
        "        self.value = 0\n",
        "    def up(self):\n",
        "        self.value = self.value + 1  \n",
        "    def jump(self,jump_size):\n",
        "        self.value = self.value + jump_size\n",
        "    def __repr__(self):\n",
        "        return str(self.value)        "
      ],
      "id": "6b208b24-11c0-4ee7-8069-3e3d98342b82"
    },
    {
      "cell_type": "code",
      "execution_count": 9,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = UpJump_Ver2()"
      ],
      "id": "67f341b0-18df-4094-9f30-35819692e94c"
    },
    {
      "cell_type": "code",
      "execution_count": 10,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.up()"
      ],
      "id": "5970e315-22eb-4b30-a13b-53770333aea7"
    },
    {
      "cell_type": "code",
      "execution_count": 11,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.jump(2)"
      ],
      "id": "804406ac-14e8-492e-92ef-526746a6a9c6"
    },
    {
      "cell_type": "code",
      "execution_count": 12,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "777112ad-22f7-4443-b6a2-720e9e0ccf3c"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 예시3: UpJump ver2의 다른 구현"
      ],
      "id": "9c6b5c19-86e0-433c-a9b3-99e6193b65c0"
    },
    {
      "cell_type": "code",
      "execution_count": 13,
      "metadata": {},
      "outputs": [],
      "source": [
        "class UpJump_Ver2(UpJump):\n",
        "    def jump(self,jump_size):\n",
        "        self.value = self.value + jump_size    "
      ],
      "id": "bd1720d4-1772-4e2b-80a7-cf585b27b897"
    },
    {
      "cell_type": "code",
      "execution_count": 14,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = UpJump_Ver2()"
      ],
      "id": "9920c0cb-2a2c-49ea-b307-6a92ba5505b8"
    },
    {
      "cell_type": "code",
      "execution_count": 15,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.up()"
      ],
      "id": "5995ea6e-ddce-49fb-a9ea-fb55c7a263f3"
    },
    {
      "cell_type": "code",
      "execution_count": 16,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.jump(2)"
      ],
      "id": "ceb4b006-8c4e-4b0b-b320-db2512bc6a54"
    },
    {
      "cell_type": "code",
      "execution_count": 17,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "631d60da-087f-4a07-afbe-7c6db5d521ff"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "## 꿀팁\n",
        "\n",
        "`-` 클래스를 조금 수정하고 싶을때, 아래와 같은 문법을 이용하면 편리하다.\n",
        "\n",
        "``` python\n",
        "class 새로운_클래스_이름(수정할_클래스_이름): \n",
        "    def 수정_및_추가할_함수이름(self,...):\n",
        "        ...\n",
        "```\n",
        "\n",
        "`-` 사용예시"
      ],
      "id": "c2c4b8e1-78ab-416e-80e3-29ef58e429c0"
    },
    {
      "cell_type": "code",
      "execution_count": 18,
      "metadata": {},
      "outputs": [],
      "source": [
        "class UpJump_Ver3(UpJump_Ver2):\n",
        "    def __repr__(self):\n",
        "        return '현재의 이 인스턴스의 value는 {}입니다.'.format(self.value)"
      ],
      "id": "0e97ca15-984a-45bd-88c6-27e2b7c5292b"
    },
    {
      "cell_type": "code",
      "execution_count": 19,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=UpJump_Ver3()"
      ],
      "id": "e927b5ed-483d-4827-b4a5-87fdfbf4330e"
    },
    {
      "cell_type": "code",
      "execution_count": 20,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "0186d7d6-2265-4dc9-86a0-bd727de0deb4"
    },
    {
      "cell_type": "code",
      "execution_count": 21,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.jump(50)"
      ],
      "id": "319c4387-baed-42f1-adda-421ca2b00e84"
    },
    {
      "cell_type": "code",
      "execution_count": 22,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "17db8cab-cb62-4eaf-a670-15eeb5858ab8"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "# 클래스공부 4단계: 파이썬의 비밀 (2)\n",
        "\n",
        "## 비밀6: `__add__`\n",
        "\n",
        "### ***motive***\n",
        "\n",
        "`-` 모티브: 아래의 연산구조를 관찰하자."
      ],
      "id": "13245645-4284-4b3e-a833-69f8dc140794"
    },
    {
      "cell_type": "code",
      "execution_count": 23,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=1\n",
        "b=2 \n",
        "a+b"
      ],
      "id": "e68c3bd6-fde4-4c84-8f9d-eef44dd272e6"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   a라는 인스턴스와 b라는 인스턴스를 +라는 기호가 연결하고 있다.\n",
        "\n",
        "`-` 이번에는 아래의 연산구조를 관찰하자."
      ],
      "id": "fb85a36c-4498-48e3-953b-8c1ad936783e"
    },
    {
      "cell_type": "code",
      "execution_count": 24,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=[1,2]\n",
        "b=[3,4]\n",
        "a+b"
      ],
      "id": "09ef66e5-9549-450f-9787-a0b344bf4237"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   a라는 인스턴스와 b라는 인스턴스를 +라는 기호가 연결하고 있다.\n",
        "\n",
        "`-` 동작이 다른 이유?\n",
        "\n",
        "-   클래스를 배우기 이전: int자료형의 `+`는 “정수의 덧셈”을 의미하고\n",
        "    list자료형의 `+`는 “자료의 추가”를 의미한다.\n",
        "-   클래스를 배운 이후: 아마 클래스는 `+`라는 연산을 정의하는 숨겨진\n",
        "    메소드가 있을것이다. (print가 그랬듯이) 그리고 int클래스에서는 그\n",
        "    메소드를 “정수의 덧셈”이 되도록 정의하였고 list클래스에서는 그\n",
        "    메소드를 “자료의 추가”를 의미하도록 정의하였다.\n",
        "\n",
        "`-` 아래의 결과를 관찰"
      ],
      "id": "96f88cf3-407c-425a-97d6-93b4f576150f"
    },
    {
      "cell_type": "code",
      "execution_count": 25,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=1\n",
        "b=2"
      ],
      "id": "f4f0dde0-56e8-48bd-9753-172d733b8b4a"
    },
    {
      "cell_type": "code",
      "execution_count": 29,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__add__(b)"
      ],
      "id": "65165032-06ec-4354-b1a1-3dfd1f2bb31d"
    },
    {
      "cell_type": "code",
      "execution_count": 30,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.__add__(a)"
      ],
      "id": "8a9fb0a1-8e8e-40e8-b8da-8c23f118c287"
    },
    {
      "cell_type": "code",
      "execution_count": 31,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=[1,2]\n",
        "b=[3,4]"
      ],
      "id": "c45b0642-1a76-478d-9398-db8201d4a617"
    },
    {
      "cell_type": "code",
      "execution_count": 34,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__add__(b) # a+b "
      ],
      "id": "29d37b65-6e02-40be-9d72-90b8c33d5472"
    },
    {
      "cell_type": "code",
      "execution_count": 35,
      "metadata": {},
      "outputs": [],
      "source": [
        "b.__add__(a) # b+a "
      ],
      "id": "2849a30b-17f9-4398-9224-4e203e503cce"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 확인: a+b는 사실 내부적으로 `a.__add__(b)`의 축약구문이다.\n",
        "\n",
        "`-` 추측: 따라서 만약 `a.__add__(b)`의 기능을 바꾸면 (재정의하면) a+b의\n",
        "기능도 바뀔 것이다.\n",
        "\n",
        "### ***Student_Ver2: `__add__`의 사용***\n",
        "\n",
        "`-` Student 클래스 선언"
      ],
      "id": "ce4cc54b-b611-439f-bd23-64d17d6653d0"
    },
    {
      "cell_type": "code",
      "execution_count": 68,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student:\n",
        "    def __init__(self, age=20.0, semester=0): \n",
        "        self.age = age\n",
        "        self.semester = semester\n",
        "        print(\"입학을 축하합니다. 당신의 나이는 {}이고 현재 학기는 {}학기 입니다.\".format(self.age,self.semester))\n",
        "    def __add__(self,registration_status): \n",
        "        if registration_status=='휴학': \n",
        "            self.age=self.age+0.5\n",
        "        elif registration_status=='등록':\n",
        "            self.age=self.age+0.5 \n",
        "            self.semester= self.semester+1 \n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        나이: {} <br/>\n",
        "        학기: {} <br/>\n",
        "        \"\"\"\n",
        "        return html_str.format(self.age,self.semester)"
      ],
      "id": "c64faa6b-cbfd-43bd-b89e-d20e98ba1dbe"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 사용"
      ],
      "id": "c27a52a7-4122-48cd-92ca-9321c2c4282d"
    },
    {
      "cell_type": "code",
      "execution_count": 69,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student()"
      ],
      "id": "7f58c252-297a-4634-b518-7ca51fc82e47"
    },
    {
      "cell_type": "code",
      "execution_count": 70,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram"
      ],
      "id": "e5e4cb99-5932-45bd-bd94-5320b1ae8c0f"
    },
    {
      "cell_type": "code",
      "execution_count": 71,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'\n",
        "boram"
      ],
      "id": "3ffa9896-27ac-40d6-9ea9-6dcf06b18010"
    },
    {
      "cell_type": "code",
      "execution_count": 72,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '휴학'\n",
        "boram"
      ],
      "id": "3dd512be-7499-4cf1-9f80-de2c44be045d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 잘못된 사용"
      ],
      "id": "10d024da-f90a-4c5f-99d6-9a75f52ad47a"
    },
    {
      "cell_type": "code",
      "execution_count": 49,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student()"
      ],
      "id": "e657175e-84f1-423a-afad-2b169ff2c68e"
    },
    {
      "cell_type": "code",
      "execution_count": 54,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'+ '휴학' + '등록' + '휴학'"
      ],
      "id": "637592e1-2cea-464c-ac1a-170eaf800f02"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   에러가?\n",
        "\n",
        "`-` 올바른 코드"
      ],
      "id": "19cf12b6-0066-439c-9e5c-9236349267fb"
    },
    {
      "cell_type": "code",
      "execution_count": 55,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student_Ver2:\n",
        "    def __init__(self, age=20.0, semester=0): \n",
        "        self.age = age\n",
        "        self.semester = semester\n",
        "        print(\"입학을 축하합니다. 당신의 나이는 {}이고 현재 학기는 {}학기 입니다.\".format(self.age,self.semester))\n",
        "    def __add__(self,registration_status): \n",
        "        if registration_status=='휴학': \n",
        "            self.age = self.age+0.5\n",
        "        elif registration_status=='등록':\n",
        "            self.age = self.age+0.5 \n",
        "            self.semester = self.semester+1 \n",
        "        return self \n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        나이: {} <br/>\n",
        "        학기: {} <br/>\n",
        "        \"\"\"\n",
        "        return html_str.format(self.age,self.semester)"
      ],
      "id": "e0f7fa65-9dfa-4649-84d4-a02c2a3d7cd1"
    },
    {
      "cell_type": "code",
      "execution_count": 56,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student_Ver2()"
      ],
      "id": "8c10b901-9272-4a97-8922-e4d6ccf30992"
    },
    {
      "cell_type": "code",
      "execution_count": 61,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + \"등록\""
      ],
      "id": "fc7547df-3fe5-4655-9370-967b97adf5fe"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***Student_Ver2의 다른구현1***"
      ],
      "id": "d777c6ff-6ee2-42c2-9e5a-2fbc3a8efc8d"
    },
    {
      "cell_type": "code",
      "execution_count": 73,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student_Ver2(Student):\n",
        "    def __add__(self,registration_status): \n",
        "        if registration_status=='휴학': \n",
        "            self.age = self.age+0.5\n",
        "        elif registration_status=='등록':\n",
        "            self.age = self.age+0.5 \n",
        "            self.semester = self.semester+1 \n",
        "        return self"
      ],
      "id": "a69650a4-5271-4b1c-8213-4781630ce1d8"
    },
    {
      "cell_type": "code",
      "execution_count": 74,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student_Ver2()"
      ],
      "id": "4198b0fa-a094-47b7-ab7a-6ea6bb20d1b9"
    },
    {
      "cell_type": "code",
      "execution_count": 75,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록'+ '휴학' + '등록' + '휴학'"
      ],
      "id": "148d3241-b9b9-455f-b145-9a9d8d814d50"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***Student_Ver2의 다른구현2***\n",
        "\n",
        "-   요거까지는 지금 몰라도 됩니다"
      ],
      "id": "fbc0ad47-f862-461a-97ea-31630c474c0f"
    },
    {
      "cell_type": "code",
      "execution_count": 80,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Student_Ver2(Student):\n",
        "    def __add__(self,registration_status): \n",
        "        super().__add__(registration_status)\n",
        "        return self"
      ],
      "id": "e4f14087-bc4b-4a7a-9e35-4d9d7f7fa515"
    },
    {
      "cell_type": "code",
      "execution_count": 81,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student_Ver2()"
      ],
      "id": "87524983-6ae6-4612-a171-2c5f612e1fa3"
    },
    {
      "cell_type": "code",
      "execution_count": 82,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록' + '휴학' + '등록' + '휴학'"
      ],
      "id": "6877ae1e-e99b-416a-bcfd-a79c991be4ef"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀6: `a+b`는 사실 `a.__add__(b)`의 축약형이다.\n",
        "\n",
        "## 비밀7: `__getitem__`\n",
        "\n",
        "### ***motive***"
      ],
      "id": "f58a48bb-fe5f-43cc-9d0a-8436a5f0908d"
    },
    {
      "cell_type": "code",
      "execution_count": 83,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=[11,22,32]"
      ],
      "id": "a473dd99-6b0c-44b3-9f1c-3fbfbdf3b88e"
    },
    {
      "cell_type": "code",
      "execution_count": 84,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0]"
      ],
      "id": "52aa075e-6db4-467c-b945-e1faf61142b0"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   이거 좋아보인다?"
      ],
      "id": "c150577a-0b3d-410b-9bf7-c76ed01f19f2"
    },
    {
      "cell_type": "code",
      "execution_count": 87,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__getitem__(0) # a[0]"
      ],
      "id": "d7c6a6f1-6e5e-4a06-b7f2-780a18d44d4a"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   이런거였어?\n",
        "\n",
        "### ***RPS_Ver2: `__getitem__`의 사용***"
      ],
      "id": "3e9ca696-8253-49c7-bb48-fec943a08209"
    },
    {
      "cell_type": "code",
      "execution_count": 88,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS:\n",
        "    def __init__(self,candidate):\n",
        "        self.candidate = candidate\n",
        "        self.actions = list() \n",
        "    def pick(self):\n",
        "        self.actions.append(np.random.choice(self.candidate))        \n",
        "    def _repr_html_(self):\n",
        "        html_str = \"\"\"\n",
        "        낼 수 있는 패: {} <br/>\n",
        "        기록: {}\n",
        "        \"\"\"        \n",
        "        return html_str.format(self.candidate,self.actions)"
      ],
      "id": "0fabe7b7-e631-4ec9-8e9f-1fa98f6cf131"
    },
    {
      "cell_type": "code",
      "execution_count": 92,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS(['가위','바위','보'])"
      ],
      "id": "06091157-6e97-48a5-8104-49499eddfa4c"
    },
    {
      "cell_type": "code",
      "execution_count": 96,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "a.pick()"
      ],
      "id": "894e9809-6935-4ec3-b5d6-ef772eb92a6a"
    },
    {
      "cell_type": "code",
      "execution_count": 97,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.actions"
      ],
      "id": "d625afab-6a16-4676-bd89-c6ed49fe1cfe"
    },
    {
      "cell_type": "code",
      "execution_count": 100,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0], a[1]"
      ],
      "id": "bf7dc13b-13ab-46d0-af7e-c2149b70ab0b"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   결과가 ‘가위’, ’바위’로 나오면 좋겠다.. 물론 지금은 불가능해"
      ],
      "id": "85da8ff8-bce0-4c81-ba06-b8f148afd9b1"
    },
    {
      "cell_type": "code",
      "execution_count": 104,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver2(RPS):\n",
        "    def __getitem__(self,item):\n",
        "        return self.actions[item]"
      ],
      "id": "8f1ecdb1-9ba2-4c84-a299-0f15aaf633b7"
    },
    {
      "cell_type": "code",
      "execution_count": 105,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver2(['가위','바위','보'])"
      ],
      "id": "85c3e27a-4a50-49ab-9276-04e2f74961f4"
    },
    {
      "cell_type": "code",
      "execution_count": 106,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "a.pick()\n",
        "a.pick()"
      ],
      "id": "3745326f-28bf-4b94-b5c1-c5075486bd3d"
    },
    {
      "cell_type": "code",
      "execution_count": 107,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "283b54b0-b33f-405f-853b-5a381ca822b5"
    },
    {
      "cell_type": "code",
      "execution_count": 116,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0]"
      ],
      "id": "2e2ed367-3093-429f-a28c-4dcd7034fa64"
    },
    {
      "cell_type": "code",
      "execution_count": 117,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[:2]"
      ],
      "id": "1f66078b-59a1-4118-8f98-de35e2acdadf"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀7: `a[0]`는 `a.__getitem__(0)`의 축약형이다.\n",
        "\n",
        "## 비밀8: `__setitem__`\n",
        "\n",
        "### ***motive***"
      ],
      "id": "41a012c2-5ae3-4e4c-ac3d-305198ab9621"
    },
    {
      "cell_type": "code",
      "execution_count": 118,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver2(['가위','바위'])\n",
        "a"
      ],
      "id": "3f5a5a59-9aaa-41e5-84c7-d28de583fed1"
    },
    {
      "cell_type": "code",
      "execution_count": 119,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "a.pick()\n",
        "a"
      ],
      "id": "1c42ea45-110c-4743-a977-36a25189e177"
    },
    {
      "cell_type": "code",
      "execution_count": 120,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0]"
      ],
      "id": "3ec880c0-9f6c-4b1c-9ee6-599149bd869a"
    },
    {
      "cell_type": "code",
      "execution_count": 121,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0] = '보' "
      ],
      "id": "99b23a3e-5173-4d95-9168-4677af53d05d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   경우에 따라서는 이런 문법이 필요하기도 하다.\n",
        "\n",
        "### ***RPS_Ver3: `__setitem__` 사용***\n",
        "\n",
        "`-` 관찰"
      ],
      "id": "ff6a7577-1510-4bfc-b9c4-2572ad46e0bc"
    },
    {
      "cell_type": "code",
      "execution_count": 123,
      "metadata": {},
      "outputs": [],
      "source": [
        "lst = [1,2,3]"
      ],
      "id": "647f7361-3725-404c-9380-fe460401212e"
    },
    {
      "cell_type": "code",
      "execution_count": 124,
      "metadata": {},
      "outputs": [],
      "source": [
        "lst.__setitem__(0,11)"
      ],
      "id": "186a0757-cd33-4f4a-8df4-b87935ebf1e2"
    },
    {
      "cell_type": "code",
      "execution_count": 125,
      "metadata": {},
      "outputs": [],
      "source": [
        "lst"
      ],
      "id": "50bde749-e45e-47b6-bc3b-e719428bec73"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` RPS예제"
      ],
      "id": "7ab16a7c-91cb-435a-b66f-4c8d9faa1760"
    },
    {
      "cell_type": "code",
      "execution_count": 126,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver3(RPS_Ver2):\n",
        "    def __setitem__(self,index,val):\n",
        "        self.actions[index] = val"
      ],
      "id": "2939163b-a32e-452d-8603-af40e247a795"
    },
    {
      "cell_type": "code",
      "execution_count": 127,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=RPS_Ver3(['가위','바위','보'])"
      ],
      "id": "3d194d9b-1039-473c-93a6-24e3e7f82c18"
    },
    {
      "cell_type": "code",
      "execution_count": 128,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()"
      ],
      "id": "04faea21-7c98-4231-b929-1ce890ae766c"
    },
    {
      "cell_type": "code",
      "execution_count": 129,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "37301247-2cae-4421-ad89-23ba7ecadb4e"
    },
    {
      "cell_type": "code",
      "execution_count": 131,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0]='가위'"
      ],
      "id": "3074d699-ea92-4895-8542-69fffcb4e3af"
    },
    {
      "cell_type": "code",
      "execution_count": 132,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "0ae5a3b1-83f0-48b2-a8d9-8ecb079e4ccb"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀8: `a[0]=11`는 `a.__setitem__(0,11)`의 축약형이다.\n",
        "\n",
        "## 비밀9: `__len__`\n",
        "\n",
        "### ***motive***"
      ],
      "id": "1ed0ac3b-8568-4fb1-83ec-f0b8ae15f259"
    },
    {
      "cell_type": "code",
      "execution_count": 139,
      "metadata": {},
      "outputs": [],
      "source": [
        "a= RPS_Ver3(['가위','바위','보'])\n",
        "a"
      ],
      "id": "760c4fed-f77c-4698-ac63-c40a1603acd6"
    },
    {
      "cell_type": "code",
      "execution_count": 140,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "a.pick()\n",
        "a.pick()"
      ],
      "id": "258174c9-eea8-497d-98e2-c991ca4a92fe"
    },
    {
      "cell_type": "code",
      "execution_count": 141,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "2a12cf8d-604a-48d4-9496-7fcf991d2884"
    },
    {
      "cell_type": "code",
      "execution_count": 142,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[0],a[1],a[2]"
      ],
      "id": "5b9d94b3-29d3-417c-9c7d-9486b0241d5b"
    },
    {
      "cell_type": "code",
      "execution_count": 143,
      "metadata": {},
      "outputs": [],
      "source": [
        "len(a)"
      ],
      "id": "1f13560e-95b4-4125-bc93-cbc75350ad85"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***RPS_Ver4: `__len__` 의 사용***"
      ],
      "id": "a1a29353-de64-4abb-96db-4259658d02de"
    },
    {
      "cell_type": "code",
      "execution_count": 145,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver4(RPS_Ver2):\n",
        "    def __len__(self):\n",
        "        return len(self.actions)"
      ],
      "id": "a709deca-70ea-48fa-8255-25bc881d400e"
    },
    {
      "cell_type": "code",
      "execution_count": 146,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver4(['가위','바위','보'])\n",
        "a"
      ],
      "id": "02aa010f-3504-4b8d-9629-552eb4e05a88"
    },
    {
      "cell_type": "code",
      "execution_count": 147,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "a.pick()\n",
        "a.pick()\n",
        "a.pick()"
      ],
      "id": "d982c836-7cd6-4e58-b880-f1d6feb87ca8"
    },
    {
      "cell_type": "code",
      "execution_count": 148,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "a4c93125-c5ae-4374-b456-8d79aacd9e91"
    },
    {
      "cell_type": "code",
      "execution_count": 149,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__len__() # len(a.actions)"
      ],
      "id": "2786e0dc-b382-4314-acb8-f1cd0c399153"
    },
    {
      "cell_type": "code",
      "execution_count": 150,
      "metadata": {},
      "outputs": [],
      "source": [
        "len(a) # a.__len__()"
      ],
      "id": "6a94b93c-e04c-4442-94f8-405e3d6c129b"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀9: `a.__len__()`는 `len(a)`의 축약형이다.\n",
        "\n",
        "## 비밀10: 비교연산자\n",
        "\n",
        "### ***motive1***"
      ],
      "id": "502f656b-021b-4a2f-9871-056e8ed32d76"
    },
    {
      "cell_type": "code",
      "execution_count": 153,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver4(['가위'])\n",
        "b = RPS_Ver4(['가위'])"
      ],
      "id": "519963db-147b-4e04-abbe-13b773bfc512"
    },
    {
      "cell_type": "code",
      "execution_count": 154,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "b.pick()"
      ],
      "id": "b45dc600-002d-4d98-8d2f-21170e6f71b2"
    },
    {
      "cell_type": "code",
      "execution_count": 155,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "26157840-5134-478b-abe1-c2ee3e00ff2a"
    },
    {
      "cell_type": "code",
      "execution_count": 156,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "24e29923-27fd-4785-887c-ee11714bf2fb"
    },
    {
      "cell_type": "code",
      "execution_count": 158,
      "metadata": {},
      "outputs": [],
      "source": [
        "a == b"
      ],
      "id": "db9d8b11-15bd-4a21-b5c9-45cf0b9d888a"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   `가위 == 가위` 이면 True가 나오면 좋겠구만.."
      ],
      "id": "3492b88c-60d8-48ad-a60d-6e7b5effb3bf"
    },
    {
      "cell_type": "code",
      "execution_count": 160,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[-1] == b[-1] "
      ],
      "id": "8936bbe9-a77b-4050-8f04-5d4956ce4fdf"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   이렇게 하면 되긴하지..\n",
        "\n",
        "### ***RPS_Ver5: `__eq__` 의 사용***\n",
        "\n",
        "`-` 관찰"
      ],
      "id": "541d341d-1330-49c5-b9df-3c58a57dbced"
    },
    {
      "cell_type": "code",
      "execution_count": 161,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = 1"
      ],
      "id": "f6286cd9-b400-4b46-9b4e-4488c0f6eae6"
    },
    {
      "cell_type": "code",
      "execution_count": 164,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__eq__(1) # a == 1"
      ],
      "id": "1d546444-867b-42c5-914f-672009ad10ea"
    },
    {
      "cell_type": "code",
      "execution_count": 167,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__eq__(2) # a == 2 "
      ],
      "id": "8f6c5a90-5a41-4ea1-9479-ee654188111f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 구현"
      ],
      "id": "f5f60f3c-0e7d-4d4d-a1fa-47bbe1e17c54"
    },
    {
      "cell_type": "code",
      "execution_count": 216,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver5(RPS_Ver4):\n",
        "    def __eq__(self,other):\n",
        "        return self[-1] == other[-1]"
      ],
      "id": "80d56f09-62ab-4233-a282-a38aa28f2f95"
    },
    {
      "cell_type": "code",
      "execution_count": 217,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver5(['가위','바위'])\n",
        "b = RPS_Ver5(['가위','바위'])"
      ],
      "id": "195daaf3-5425-4ccf-a033-a95d90b84655"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 1회 대결"
      ],
      "id": "d7fbd861-60a1-4f76-838b-cbf4e539910e"
    },
    {
      "cell_type": "code",
      "execution_count": 218,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "b.pick()"
      ],
      "id": "e20f3c77-bb55-4566-b07f-c910af3ef1c3"
    },
    {
      "cell_type": "code",
      "execution_count": 219,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "50a2e28b-4ce1-47cd-b92f-95ef643588d9"
    },
    {
      "cell_type": "code",
      "execution_count": 220,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "ac755145-3aba-4b4a-89af-8b8feec7bb0b"
    },
    {
      "cell_type": "code",
      "execution_count": 221,
      "metadata": {},
      "outputs": [],
      "source": [
        "a == b"
      ],
      "id": "1576d8ee-aef8-481f-973a-b3886aad80ac"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 2회 대결"
      ],
      "id": "c85ec8a1-9be6-44f6-9332-9dcd0e2c96b9"
    },
    {
      "cell_type": "code",
      "execution_count": 222,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "b.pick()"
      ],
      "id": "3aa53a4e-b751-481a-885c-477f74e68fe7"
    },
    {
      "cell_type": "code",
      "execution_count": 223,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "9557f686-dd49-45cb-b3a2-79066420c4d7"
    },
    {
      "cell_type": "code",
      "execution_count": 224,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "2cb4cb44-89e9-4849-b2ea-1c9a4d596ba1"
    },
    {
      "cell_type": "code",
      "execution_count": 225,
      "metadata": {},
      "outputs": [],
      "source": [
        "a == b"
      ],
      "id": "a4bed330-929b-4c40-a825-bcbf211c6258"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 3회 대결"
      ],
      "id": "d4ef9975-6319-4243-8d6d-b67d55491a30"
    },
    {
      "cell_type": "code",
      "execution_count": 226,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "b.pick()"
      ],
      "id": "310f4458-5b95-48ba-bbd2-81c4d3ba8f55"
    },
    {
      "cell_type": "code",
      "execution_count": 227,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "458bdf73-5fcf-4151-9cda-ed42dc38ef72"
    },
    {
      "cell_type": "code",
      "execution_count": 228,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "de2580f7-e3d5-4126-af52-61fe8a06fc62"
    },
    {
      "cell_type": "code",
      "execution_count": 229,
      "metadata": {},
      "outputs": [],
      "source": [
        "a == b"
      ],
      "id": "8330588a-05e9-4cc4-981e-d88b4025f4b2"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***motive2***"
      ],
      "id": "95335a2b-7053-43b5-9c7f-cb940c922eda"
    },
    {
      "cell_type": "code",
      "execution_count": 185,
      "metadata": {},
      "outputs": [],
      "source": [
        "a[-1], b[-1]"
      ],
      "id": "61787796-cde2-4292-9094-f088be1dec96"
    },
    {
      "cell_type": "code",
      "execution_count": 186,
      "metadata": {},
      "outputs": [],
      "source": [
        "a > b"
      ],
      "id": "eb721e7d-62db-40e6-af0a-8f0882b293ca"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   False 가 나오면 좋겟구만..\n",
        "\n",
        "### ***RPS_Ver6: `__gt__` 의 사용***\n",
        "\n",
        "`-` 관찰"
      ],
      "id": "e2dfb625-8e1e-46b6-8ba1-823aec9b857c"
    },
    {
      "cell_type": "code",
      "execution_count": 187,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = 1"
      ],
      "id": "f0597eeb-d4cf-4e11-8144-3389f459da0f"
    },
    {
      "cell_type": "code",
      "execution_count": 188,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__gt__(1) # a>1"
      ],
      "id": "7d9385f3-c580-4fa0-ba02-dabcb9b37fcf"
    },
    {
      "cell_type": "code",
      "execution_count": 189,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.__gt__(0) # a>0 "
      ],
      "id": "d1001999-255d-46fc-aea6-57b72b4bd9ce"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` **예비학습**"
      ],
      "id": "44ce2107-0ea9-4ca2-9db1-0b68e375d7d1"
    },
    {
      "cell_type": "code",
      "execution_count": 232,
      "metadata": {},
      "outputs": [],
      "source": [
        "[a[-1],b[-1]]"
      ],
      "id": "fe5363d7-39ab-4a6c-9ae8-8ddbf2259ebb"
    },
    {
      "cell_type": "code",
      "execution_count": 233,
      "metadata": {},
      "outputs": [],
      "source": [
        "[a[-1],b[-1]] in [['가위','보'],['바위','가위'],['보','바위']]"
      ],
      "id": "4ad92fa1-25db-4916-9846-42fc77899a17"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 구현"
      ],
      "id": "6c729611-8f87-42ee-8c9e-3813b37ab8e1"
    },
    {
      "cell_type": "code",
      "execution_count": 234,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver6(RPS_Ver5):\n",
        "    def __gt__(self,other):\n",
        "        return [self[-1],other[-1]] in [['가위','보'],['바위','가위'],['보','바위']]"
      ],
      "id": "c88866c8-b7c9-4599-bb35-75c971a03ee1"
    },
    {
      "cell_type": "code",
      "execution_count": 235,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver6(['가위','바위','보'])\n",
        "b = RPS_Ver6(['가위','바위','보'])"
      ],
      "id": "fcf450c1-70d6-4d9b-a9d9-b7e40a871604"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 1회대결"
      ],
      "id": "6777212d-2716-4efe-a74f-62615f177879"
    },
    {
      "cell_type": "code",
      "execution_count": 236,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick() \n",
        "b.pick()"
      ],
      "id": "7e336058-a655-4c91-af05-e6d534608f7c"
    },
    {
      "cell_type": "code",
      "execution_count": 237,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "2142524c-9f45-4a51-a27b-077ce4c13fc3"
    },
    {
      "cell_type": "code",
      "execution_count": 238,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "edfccb72-3a1c-40e7-bb26-49288e828e57"
    },
    {
      "cell_type": "code",
      "execution_count": 240,
      "metadata": {},
      "outputs": [],
      "source": [
        "a>b, a==b"
      ],
      "id": "cde45114-fb10-4e01-8cae-aa63f6debaef"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 2회대결"
      ],
      "id": "7a6e8177-3785-4fc3-8ddc-b28a19465d28"
    },
    {
      "cell_type": "code",
      "execution_count": 241,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick() \n",
        "b.pick()"
      ],
      "id": "ee799dc5-596e-40bf-8376-46d981a4958b"
    },
    {
      "cell_type": "code",
      "execution_count": 242,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "d7a98b62-235f-48c1-9733-a7ed3cac0a6b"
    },
    {
      "cell_type": "code",
      "execution_count": 243,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "ba23f80b-700c-436a-894a-8866e84f7d4c"
    },
    {
      "cell_type": "code",
      "execution_count": 245,
      "metadata": {},
      "outputs": [],
      "source": [
        "a>b, a==b"
      ],
      "id": "dd53c67d-029d-4490-9c63-5d6f7d54e685"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***motive3***"
      ],
      "id": "0a43bf8b-fb11-43a7-9afd-47c38e7dba06"
    },
    {
      "cell_type": "code",
      "execution_count": 246,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "46624ad7-4c1a-4485-a237-d7081746f8e1"
    },
    {
      "cell_type": "code",
      "execution_count": 247,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "58112bd7-0851-4908-bf70-4a7a98c03cbe"
    },
    {
      "cell_type": "code",
      "execution_count": 248,
      "metadata": {},
      "outputs": [],
      "source": [
        "a>=b"
      ],
      "id": "6de0c6e4-98d8-484c-a2ed-ea1995204eef"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   True로 나오면 좋겠구만.."
      ],
      "id": "4b350594-b364-4db2-8511-c0bb8109dcc7"
    },
    {
      "cell_type": "code",
      "execution_count": 249,
      "metadata": {},
      "outputs": [],
      "source": [
        "a < b"
      ],
      "id": "458aaa73-0929-4df9-ba05-8e93d9435f70"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   이것도 정의 새로 해야겠는걸?\n",
        "\n",
        "### ***RPS_Ver7: `__ge__`, `__lt__`, `__le__` 의 사용***\n",
        "\n",
        "`-` 관찰: 생략\n",
        "\n",
        "`-` 비교연산자 정리\n",
        "\n",
        "| 특수메소드 |      의미       |\n",
        "|:----------:|:---------------:|\n",
        "|  `__eq__`  | `self == other` |\n",
        "|  `__gt__`  | `self > other`  |\n",
        "|  `__lt__`  | `self < other`  |\n",
        "|  `__ge__`  | `self >= other` |\n",
        "|  `__le__`  | `self <= other` |\n",
        "\n",
        "`-` 구현"
      ],
      "id": "04d4bfad-57e0-48d0-b4e9-86adcc19776b"
    },
    {
      "cell_type": "code",
      "execution_count": 252,
      "metadata": {},
      "outputs": [],
      "source": [
        "class RPS_Ver7(RPS_Ver6):\n",
        "    def __ge__(self,other):\n",
        "        return (self == other) or (self > other)\n",
        "    def __lt__(self,other):\n",
        "        return not (self >= other)\n",
        "    def __le__(self,other):\n",
        "        return (self == other) or (self < other)"
      ],
      "id": "498638da-17f4-4877-a6c6-ff076fe05296"
    },
    {
      "cell_type": "code",
      "execution_count": 258,
      "metadata": {},
      "outputs": [],
      "source": [
        "a = RPS_Ver7(['가위','바위','보'])\n",
        "b = RPS_Ver7(['가위','바위','보'])"
      ],
      "id": "f6fff8fb-b49f-44e7-9b04-dff39402afb0"
    },
    {
      "cell_type": "code",
      "execution_count": 259,
      "metadata": {},
      "outputs": [],
      "source": [
        "a.pick()\n",
        "b.pick()"
      ],
      "id": "0142cc0f-0a70-4e34-8f24-3691aa474e8f"
    },
    {
      "cell_type": "code",
      "execution_count": 260,
      "metadata": {},
      "outputs": [],
      "source": [
        "a"
      ],
      "id": "073658fb-478a-488e-bc6d-30649ec6d744"
    },
    {
      "cell_type": "code",
      "execution_count": 261,
      "metadata": {},
      "outputs": [],
      "source": [
        "b"
      ],
      "id": "6456f11b-d61b-4bd2-907e-c4a8831faef6"
    },
    {
      "cell_type": "code",
      "execution_count": 262,
      "metadata": {},
      "outputs": [],
      "source": [
        "a==b, a>b, a<b, a>=b, a<=b "
      ],
      "id": "1d4c45b5-be2c-44fe-a2e5-9b68a69f9b3f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀10: `__eq__`, `__gt__`, `__lt__`, `__ge__`, `__le__`는\n",
        "> 각각 `==`, `>`, `<`, `>=`, `<=` 를 재정의한다.\n",
        "\n",
        "## 비밀11: `__call__` $(\\star\\star\\star)$\n",
        "\n",
        "### ***함수공부***\n",
        "\n",
        "`-` 다시 함수를 공부해봅시다."
      ],
      "id": "a97a8c4a-40a8-4235-8612-f699ce993e11"
    },
    {
      "cell_type": "code",
      "execution_count": 264,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x):\n",
        "    return x+1 "
      ],
      "id": "9d03d636-825e-4c2f-8329-749557ec3b8d"
    },
    {
      "cell_type": "code",
      "execution_count": 265,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(3)"
      ],
      "id": "538788d7-05cd-4c34-97ea-b14745c6ed32"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 함수의 사용방법?\n",
        "\n",
        "-   입력으로 변수 x를 받음 = 입력으로 인스턴스 x를 받음.\n",
        "-   출력으로 변수 x+1을 리턴 = 출력으로 인스턴스 x+1을 리턴.\n",
        "\n",
        "`-` 사실1: 파이썬에서 함수는 인스턴스를 입력으로 받고 인스턴스를\n",
        "출력한다.\n",
        "\n",
        "`-` 함수의 자료형?"
      ],
      "id": "c7294cb9-324a-47f0-adfc-7176075fed1c"
    },
    {
      "cell_type": "code",
      "execution_count": 266,
      "metadata": {},
      "outputs": [],
      "source": [
        "?f"
      ],
      "id": "edaf23ef-e8aa-4d8a-8d23-151e7276d708"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   type이 function이다.\n",
        "-   f는 function class의 instance이다.\n",
        "-   결국 f 역시 하나의 오브젝트에 불과하다.\n",
        "\n",
        "`-` 사실2: 함수도 결국 인스턴스이다. -\\> 함수의 입력으로 함수를 쓸 수도\n",
        "있고 함수의 출력으로 함수가 나올 수도 있다.\n",
        "\n",
        "> “파이썬의 모든 것은 오브젝트이다.” \\<– 명언처럼 외우세여\n",
        "\n",
        "### ***함수도 인스턴스다***\n",
        "\n",
        "(예제1) 숫자입력, 함수출력"
      ],
      "id": "d2b4b9ea-0da0-4000-8d2d-dbf49117a7a1"
    },
    {
      "cell_type": "code",
      "execution_count": 268,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(a):\n",
        "    def _f(x):\n",
        "        return (x-a)**2 \n",
        "    return _f"
      ],
      "id": "86c3359b-a335-4bc7-8305-3b2e3b6a2d86"
    },
    {
      "cell_type": "code",
      "execution_count": 269,
      "metadata": {},
      "outputs": [],
      "source": [
        "g=f(10) # g(x)=(x-10)**2 "
      ],
      "id": "061f6d6d-c2f9-4d7a-8d0d-bb4c1713b876"
    },
    {
      "cell_type": "code",
      "execution_count": 270,
      "metadata": {},
      "outputs": [],
      "source": [
        "g(2) # (2-10)**2 = 64"
      ],
      "id": "9a907484-d7c5-4034-bc6b-df889aab1ed3"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   해석: $f(a)$는 $a$를 입력으로 받고 $g(x)=(x-a)^2$라는 함수를\n",
        "    리턴해주는 함수\n",
        "\n",
        "(예제1)의 다른표현: 익명함수 lambda"
      ],
      "id": "e80d9e95-9e3f-4a76-ba1a-bd9e891bd25b"
    },
    {
      "cell_type": "code",
      "execution_count": 271,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x):\n",
        "    return x+1"
      ],
      "id": "66a7df48-9d3e-42fd-9cac-8761f6d1212a"
    },
    {
      "cell_type": "code",
      "execution_count": 280,
      "metadata": {},
      "outputs": [],
      "source": [
        "f= lambda x: x+1"
      ],
      "id": "318ff6ce-b337-4cfc-9bec-10dc889bdf51"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "표현1"
      ],
      "id": "4cc09f12-fef3-44fd-9463-b13edf42e70d"
    },
    {
      "cell_type": "code",
      "execution_count": 281,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(a):\n",
        "    _f = lambda x: (x-a)**2 ### lambda x: (x-a)**2 가 실행되는 순간 함수오브젝트가 만들어지고 그것이 _f 로 저장됨 \n",
        "    return _f"
      ],
      "id": "592d674c-07e6-4c08-ba1f-9aa901e8dc26"
    },
    {
      "cell_type": "code",
      "execution_count": 282,
      "metadata": {},
      "outputs": [],
      "source": [
        "g=f(10) # g(x)=(x-10)**2 "
      ],
      "id": "5d588bba-75cd-489b-a18f-801f64ab7b4d"
    },
    {
      "cell_type": "code",
      "execution_count": 283,
      "metadata": {},
      "outputs": [],
      "source": [
        "g(3) # (3-10)**2 = 49"
      ],
      "id": "15fbaf2a-b022-46f4-9202-c629a83efe1d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "표현2"
      ],
      "id": "11f9e202-7011-4a4e-a398-a50178445810"
    },
    {
      "cell_type": "code",
      "execution_count": 286,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(a):\n",
        "    return lambda x: (x-a)**2 "
      ],
      "id": "2f14809d-bcce-4380-86f0-5598eab20e24"
    },
    {
      "cell_type": "code",
      "execution_count": 287,
      "metadata": {},
      "outputs": [],
      "source": [
        "g=f(10) # g(x)=(x-10)**2 "
      ],
      "id": "4ffa1e83-c055-4f35-b384-41a06a3ec068"
    },
    {
      "cell_type": "code",
      "execution_count": 288,
      "metadata": {},
      "outputs": [],
      "source": [
        "g(3) # (3-10)**2 = 49"
      ],
      "id": "4ec2204e-c1c2-4b92-970b-d4ba9058c2db"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   `lambda x: (x-a)**2` 는 $\\text{lambda}(x) = (x-a)^2$의 느낌으로\n",
        "    기억하면 외우기 쉽다.\n",
        "-   `lambda x: (x-a)**2` 는 “아직 이름이 없는 함수오브젝트를 (가칭\n",
        "    lambda 라고 하자) 만들고 기능은 `x`를 입력으로 하고 `(x-a)**2`를\n",
        "    출력하도록 하자” 라는 뜻으로 해석하면 된다.\n",
        "\n",
        "(예제2) 함수입력, 숫자출력"
      ],
      "id": "0514d067-84e4-48a2-9945-04855a076703"
    },
    {
      "cell_type": "code",
      "execution_count": 295,
      "metadata": {},
      "outputs": [],
      "source": [
        "def d(f,x): # 함수를 입력을 받는 함수를 정의 \n",
        "    h=0.000000000001\n",
        "    return (f(x+h)-f(x))/h "
      ],
      "id": "d03a9268-2614-4fbb-97b5-c71a77f6ebca"
    },
    {
      "cell_type": "code",
      "execution_count": 298,
      "metadata": {},
      "outputs": [],
      "source": [
        "d(f,4) # f'(4) = 2*4 = 8"
      ],
      "id": "741f03aa-92f6-4249-b303-8859429a6c75"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "(예제3) 함수입력, 함수출력"
      ],
      "id": "b7e96218-8e68-44c2-8bb8-5fa3642aebdf"
    },
    {
      "cell_type": "code",
      "execution_count": 299,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x): \n",
        "    return x**2 "
      ],
      "id": "dde6f53d-c8c5-4f76-a7be-b70f1b63084e"
    },
    {
      "cell_type": "code",
      "execution_count": 307,
      "metadata": {},
      "outputs": [],
      "source": [
        "def derivate(f): \n",
        "    # step1: 함수오브젝트 f는 입력으로 받은상태 \n",
        "    # step2: 함수오브젝트 f를 이용하여 df라는 함수를 정의 \n",
        "    def df(x): \n",
        "        h=0.000000000001\n",
        "        return (f(x+h)-f(x))/h \n",
        "    # step3: 정의된 df를 리턴\n",
        "    return df"
      ],
      "id": "bd2a874a-b00c-49c9-ad16-9d64370ae733"
    },
    {
      "cell_type": "code",
      "execution_count": 308,
      "metadata": {},
      "outputs": [],
      "source": [
        "ff = derivate(f)"
      ],
      "id": "1e68d532-5728-4554-9bd1-b3cdb066bdc9"
    },
    {
      "cell_type": "code",
      "execution_count": 309,
      "metadata": {},
      "outputs": [],
      "source": [
        "ff(7) # f의 도함수"
      ],
      "id": "e35736c0-bf01-40cb-b34c-44aa996f9b72"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**원래함수 시각화**"
      ],
      "id": "b2790e35-ea5c-41d2-b4ac-328bf7638515"
    },
    {
      "cell_type": "code",
      "execution_count": 310,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXQAAAD4CAYAAAD8Zh1EAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nj9BCV0opH6GFrpRSPkILXSmlfMT/B6MFZO2Rp90nAAAAAElFTkSuQmCC\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-1,1,100)\n",
        "plt.plot(x,f(x))"
      ],
      "id": "36319018-a9f5-4cb0-b376-6abb7fdf50f5"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "**도함수 시각화**"
      ],
      "id": "2f28b647-6cb3-49b1-ad37-fd5b93134328"
    },
    {
      "cell_type": "code",
      "execution_count": 311,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXwAAAD4CAYAAADvsV2wAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nAwzd6pkbBYfHAAAAAElFTkSuQmCC\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-1,1,100)\n",
        "plt.plot(x,f(x),label=r'$f(x)=x^2$')\n",
        "plt.plot(x,ff(x),label=r'$ff(x)=2x$')\n",
        "plt.legend()"
      ],
      "id": "cd3de78e-4e12-43d1-94d1-b88140718a28"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "(예제3)의 다른표현"
      ],
      "id": "7abc65ab-fb43-49d0-9a9d-88f2095f826b"
    },
    {
      "cell_type": "code",
      "execution_count": 312,
      "metadata": {},
      "outputs": [],
      "source": [
        "def f(x): \n",
        "    return x**2 "
      ],
      "id": "17840c26-1142-4aa3-8276-c183e3036d4d"
    },
    {
      "cell_type": "code",
      "execution_count": 314,
      "metadata": {},
      "outputs": [],
      "source": [
        "def derivate(f): \n",
        "    h=0.000000000001\n",
        "    return lambda x: (f(x+h)-f(x))/h "
      ],
      "id": "05f95e9c-b61e-44a8-a53b-889a79622d28"
    },
    {
      "cell_type": "code",
      "execution_count": 315,
      "metadata": {},
      "outputs": [],
      "source": [
        "ff = derivate(f)"
      ],
      "id": "2ecf2fa2-8032-4be4-97a5-45c6bff59866"
    },
    {
      "cell_type": "code",
      "execution_count": 316,
      "metadata": {},
      "outputs": [],
      "source": [
        "ff(10)"
      ],
      "id": "18ff7d32-45c3-44bc-beff-644074d95b5e"
    },
    {
      "cell_type": "code",
      "execution_count": 317,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAXwAAAD4CAYAAADvsV2wAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nAwzd6pkbBYfHAAAAAElFTkSuQmCC\n"
          }
        }
      ],
      "source": [
        "x = np.linspace(-1,1,100)\n",
        "plt.plot(x,f(x),label=r'$f(x)=x^2$')\n",
        "plt.plot(x,ff(x),label=r'$ff(x)=2x$')\n",
        "plt.legend()"
      ],
      "id": "48a30f1e-daa2-4d98-85fc-568422c4c23f"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "(예제4) 함수들의 리스트"
      ],
      "id": "0022cfc7-86c8-4c5e-9cdc-ce99688a2a95"
    },
    {
      "cell_type": "code",
      "execution_count": 318,
      "metadata": {},
      "outputs": [],
      "source": [
        "flst = [lambda x: x, lambda x: x**2, lambda x: x**3] \n",
        "flst"
      ],
      "id": "32b3ba28-164e-44a2-aacf-affaac0d1f36"
    },
    {
      "cell_type": "code",
      "execution_count": 324,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "2\n",
            "4\n",
            "8"
          ]
        }
      ],
      "source": [
        "for f in flst:\n",
        "    print(f(2))"
      ],
      "id": "365678f9-22aa-46f2-890f-8c06ae882799"
    },
    {
      "cell_type": "code",
      "execution_count": 325,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYIAAAD4CAYAAADhNOGaAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nqobTRKCUUjWcJgKllKrhNBEopVQN9//pBXeDmp8B1QAAAABJRU5ErkJggg==\n"
          }
        }
      ],
      "source": [
        "for f in flst: \n",
        "    plt.plot(x,f(x),'--')"
      ],
      "id": "d68cac9d-37d8-40a8-8f4f-9a23c1222b56"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "위의코드는 아래와 같음"
      ],
      "id": "191d589c-e2f5-4111-a661-782e489ab32d"
    },
    {
      "cell_type": "code",
      "execution_count": 326,
      "metadata": {},
      "outputs": [
        {
          "output_type": "display_data",
          "metadata": {},
          "data": {
            "image/png": "iVBORw0KGgoAAAANSUhEUgAAAYIAAAD4CAYAAADhNOGaAAAAOXRFWHRTb2Z0d2FyZQBNYXRwbG90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\nqobTRKCUUjWcJgKllKrhNBEopVQN9//pBXeDmp8B1QAAAABJRU5ErkJggg==\n"
          }
        }
      ],
      "source": [
        "plt.plot(x,(lambda x: x)(x),'--')\n",
        "plt.plot(x,(lambda x: x**2)(x),'--')\n",
        "plt.plot(x,(lambda x: x**3)(x),'--')"
      ],
      "id": "eca55297-bcd1-4d80-8bec-24d4320c18ab"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "### ***정리***\n",
        "\n",
        "`-` 지금까지 개념\n",
        "\n",
        "-   함수: 변수를 입력으로 받아서 변수를 출력하는 개념\n",
        "-   변수: 어떠한 값을 저장하는 용도로 쓰거나 함수의 입력 혹은 출력으로\n",
        "    사용함\n",
        "\n",
        "`-` R과 구별되는 파이썬의 독특한 테크닉 (부제: 파이썬에서 함수를 잘\n",
        "쓰려면?)\n",
        "\n",
        "-   변수든 함수이든 둘다 인스턴스임. (즉 어떠한 클래스에서 찍힌 똑같은\n",
        "    오브젝트라는 의미)\n",
        "-   변수를 함수처럼: 메소드 `lst.append(1)`은 마치 `append(lst,1)`와\n",
        "    같은 함수로 쓸 수 있음\n",
        "-   함수를 변수처럼($\\star$): 함수자체를 함수의 입력으로 혹은 출력으로\n",
        "    쓸 수도 있음. 함수를 특정 값처럼 생각해서 함수들의 list를 만들 수도\n",
        "    있다.\n",
        "\n",
        "### ***callable object***\n",
        "\n",
        "`-` 함수 오브젝트의 비밀?"
      ],
      "id": "d89a20c3-e4ed-40f4-899e-1207a2bc516d"
    },
    {
      "cell_type": "code",
      "execution_count": 327,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = lambda x: x+1 "
      ],
      "id": "28345165-d190-41e3-ba75-4b8e655f7a07"
    },
    {
      "cell_type": "code",
      "execution_count": 330,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=11"
      ],
      "id": "b3482316-f1e6-4e18-ab7c-188862a22935"
    },
    {
      "cell_type": "code",
      "execution_count": 328,
      "metadata": {},
      "outputs": [],
      "source": [
        "set(dir(f)) & {'__call__'}"
      ],
      "id": "a3ea028e-87f4-4d7b-baca-7f54bfca2f97"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   함수 오브젝트에는 숨겨진 기능 `__call__`이 있다."
      ],
      "id": "c8afd6d3-aa9e-4938-b859-74eb6ebcaa60"
    },
    {
      "cell_type": "code",
      "execution_count": 332,
      "metadata": {},
      "outputs": [],
      "source": [
        "f.__call__(3) # f(3)"
      ],
      "id": "63c53c50-b029-4ec2-8e30-1568d6ee18dd"
    },
    {
      "cell_type": "code",
      "execution_count": 333,
      "metadata": {},
      "outputs": [],
      "source": [
        "f.__call__(4) # f(4)"
      ],
      "id": "67f265c0-4988-43fa-8ad6-81bca5b86e79"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   여기에 우리가 정의한 내용이 있다.\n",
        "\n",
        "`-` 함수처럼 쓸 수 없는 인스턴스는 단지 call이 없는 것일 뿐이다."
      ],
      "id": "e89c3330-e653-4685-aff9-2c36e3ecb90f"
    },
    {
      "cell_type": "code",
      "execution_count": 334,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Klass: \n",
        "    def __init__(self):\n",
        "        self.name='guebin'"
      ],
      "id": "e1a769e6-39d6-4c29-bc97-61841620d293"
    },
    {
      "cell_type": "code",
      "execution_count": 335,
      "metadata": {},
      "outputs": [],
      "source": [
        "a=Klass()"
      ],
      "id": "308eccd8-93e5-45c3-aee0-85d7f8496213"
    },
    {
      "cell_type": "code",
      "execution_count": 336,
      "metadata": {},
      "outputs": [],
      "source": [
        "a()"
      ],
      "id": "0a4c3678-d47d-454e-b452-17404e5c0d20"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   a는 callable이 아니라고 한다."
      ],
      "id": "c27a7c6e-adb6-4971-b9a6-d5de848bf24e"
    },
    {
      "cell_type": "code",
      "execution_count": 338,
      "metadata": {},
      "outputs": [],
      "source": [
        "class Klass2(Klass): \n",
        "    def __call__(self):\n",
        "        print(self.name)"
      ],
      "id": "44121865-7d2a-4dc2-83a6-2beba8c23b02"
    },
    {
      "cell_type": "code",
      "execution_count": 339,
      "metadata": {},
      "outputs": [],
      "source": [
        "b=Klass2()"
      ],
      "id": "86c434c1-ff63-4f18-a060-40bdab7461d5"
    },
    {
      "cell_type": "code",
      "execution_count": 340,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "guebin"
          ]
        }
      ],
      "source": [
        "b()"
      ],
      "id": "73400640-4ea5-4648-b032-b02107ec4f2d"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   b는 callable object! 즉 숨겨진 메서드로 `__call__`를 가진 오브젝트!\n",
        "-   Klass는 callable object를 만들지 못하지만 Klass2는 callable object를\n",
        "    만든다.\n",
        "\n",
        "`-` 클래스로 함수를 만들기 (=함수인스턴스를 찍어내는 클래스 설계)"
      ],
      "id": "8b3eb3e1-6927-48db-b2d5-87fe0d11a931"
    },
    {
      "cell_type": "code",
      "execution_count": 341,
      "metadata": {},
      "outputs": [],
      "source": [
        "class AddConstant: \n",
        "    def __init__(self,const):\n",
        "        self.const = const \n",
        "    def __call__(self,x):\n",
        "        return x + self.const"
      ],
      "id": "b5b2ea3d-47b0-4e2a-b904-5e4b7b15a613"
    },
    {
      "cell_type": "code",
      "execution_count": 342,
      "metadata": {},
      "outputs": [],
      "source": [
        "f = AddConstant(3) # callable object생성, f.const에는 3이 저장되어있음. "
      ],
      "id": "e3daaa72-3061-468f-8f04-beb10a1b7c77"
    },
    {
      "cell_type": "code",
      "execution_count": 343,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(5) # f.const 와 5를 더하는 기능을 수행, # 즉 f(x) = x+3 을 수행함"
      ],
      "id": "5d205a3b-1ff9-4132-9120-9dc1ce2e82e3"
    },
    {
      "cell_type": "code",
      "execution_count": 344,
      "metadata": {},
      "outputs": [],
      "source": [
        "f(10) "
      ],
      "id": "fffd5ddb-426e-41c6-96cf-1e29162f110a"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "`-` 클래스도 그러고 보니까 `오브젝트` 아니었나?"
      ],
      "id": "2cd8d5b1-a561-4d6e-87d4-2b565a1c2327"
    },
    {
      "cell_type": "code",
      "execution_count": 345,
      "metadata": {},
      "outputs": [],
      "source": [
        "Student_Ver2?"
      ],
      "id": "eaf368ec-f844-438e-b42c-2297e3725bee"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "-   이것도 type 이라는 또 다른 클래스에서 (클래스를 찍는 클래스) 찍힌\n",
        "    오브젝트이구나..\n",
        "\n",
        "`-` 클래스 “오브젝트”도 함수 “오브젝트”처럼 `Student_Ver2()`와 같이\n",
        "사용하면 인스턴스를 만들었음. -\\> `Student_Ver2.__call__()` 은\n",
        "`Student_Ver2()`와 같은 역할을 할 것이다.\n",
        "\n",
        "***일반적인 구현에서 “클래스 $\\to$ 인스턴스” 과정***"
      ],
      "id": "ae1f3b10-50c4-47dc-b210-fae83585528e"
    },
    {
      "cell_type": "code",
      "execution_count": 347,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student_Ver2(age=20.0,semester=0)"
      ],
      "id": "8cfd96ea-4c00-4406-ac6b-3887b2c11e5b"
    },
    {
      "cell_type": "code",
      "execution_count": 348,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록' + '휴학' + '휴학'"
      ],
      "id": "d267e2f8-c153-4a97-84ec-533a3022925b"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "***공부를 위해 call을 이용해본 “클래스 $\\to$ 인스턴스” 과정***"
      ],
      "id": "e8a03a08-fe8f-4acd-b0f1-84d539bf5735"
    },
    {
      "cell_type": "code",
      "execution_count": 351,
      "metadata": {},
      "outputs": [
        {
          "output_type": "stream",
          "name": "stdout",
          "text": [
            "입학을 축하합니다. 당신의 나이는 20.0이고 현재 학기는 0학기 입니다."
          ]
        }
      ],
      "source": [
        "boram = Student_Ver2.__call__(age=20.0,semester=0) #\n",
        "# boram = Student_Ver2(age=20.0,semester=0)"
      ],
      "id": "6e9fce5d-7ab4-4f89-90e7-5de90f1f8f71"
    },
    {
      "cell_type": "code",
      "execution_count": 352,
      "metadata": {},
      "outputs": [],
      "source": [
        "boram + '등록' + '휴학' + '휴학'"
      ],
      "id": "39a814ab-d6a3-491f-a1d2-fab676304c40"
    },
    {
      "cell_type": "markdown",
      "metadata": {},
      "source": [
        "> 파이썬의 비밀11: `f()`와 같이 쓸 수 있는 오브젝트는 단지 `__call__` 이\n",
        "> 정의되어있는 오브젝트일 뿐이다.\n",
        "\n",
        "# 숙제 - 2022년 파이썬 입문 기말고사 참고\n",
        "\n",
        "`(1)` 플레이어A는 (가위,가위) 중 하나를 선택할 수 있고 플레이어B는\n",
        "(가위,바위) 중 하나를 선택할 수 있다. 각 플레이어는 각 패 중 하나를\n",
        "랜덤으로 선택하는 액션을 한다고 가정하자. 아래에 해당하는 확률을\n",
        "시뮬레이션을 이용하여 추정하라.\n",
        "\n",
        "-   플레이어A가 승리할 확률:\n",
        "-   플레이어B가 승리할 확률:\n",
        "-   플레이어A와 플레이어B가 비길 확률:\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint**: 50% 확률로 b가 승리하고 50% 확률로 비긴다.\n",
        "\n",
        "`(2)` 문제 (1)과 같이 아래의 상황을 가정하자.\n",
        "\n",
        "|                                         |  플레이어A  |  플레이어B  |\n",
        "|:---------------------------------------:|:-----------:|:-----------:|\n",
        "| 각 플레이어가 낼 수 있는 패 (candidate) | (가위,가위) | (가위,바위) |\n",
        "|       각 패를 선택할 확률 (prob)        |  (0.5,0.5)  |  (0.5,0.5)  |\n",
        "\n",
        "각 플레이어는 아래와 같은 규칙으로 가위바위보 결과에 따른 보상점수를\n",
        "적립한다고 하자.\n",
        "\n",
        "-   승리: 보상점수 2점 적립\n",
        "-   무승부: 보상점수 1점 적립\n",
        "-   패배: 보상점수 0점 적립\n",
        "\n",
        "100번째 대결까지 시뮬레이션을 시행하고 플레이어B가 가위를 낼 경우 얻은\n",
        "보상점수의 총합과 바위를 낼 경우 얻은 보상점수의 총합을 각각 구하라.\n",
        "플레이어B는 가위를 내는것이 유리한가? 바위를 내는것이 유리한가?\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint1**: 플레이어B는 바위를 내는 것이 유리하다.\n",
        ">\n",
        "> **hint2**: 플레이어B가 100번중에 49번 가위를 내고 51번 바위를 낸다면\n",
        "> 플레이어B가 적립할 보상점수는 각각 아래와 같다.\n",
        ">\n",
        "> -   가위를 내었을 경우: 49 \\* 1 = 49점\n",
        "> -   바위를 내었을 경우: 51 \\* 2 = 102점\n",
        "> -   총 보상점수 = 49점 + 102점 = 151점\n",
        "\n",
        "`(3)` (2)에서 얻은 데이터를 **학습**하여 플레이어B가 “가위” 혹은 “바위”\n",
        "를 선택할 확률을 매시점 조금씩 조정한다고 가정하자. 구체적으로는\n",
        "현재시점까지 얻은 보상점수의 비율로 확률을 결정한다. 예를들어\n",
        "플레이어B가 100회의 대결동안 누적한 보상점수의 총합이 아래와 같다고\n",
        "하자.\n",
        "\n",
        "-   가위를 내었을 경우 보상점수 총합 = 50점\n",
        "-   바위를 내었을 경우 보상점수 총합 = 100점\n",
        "\n",
        "그렇다면 플레이어B는 각각 (50/150,100/150) 의 확률로 (가위,바위) 중\n",
        "하나를 선택한다. 101번째 대결에 플레이어B가 가위를 내서 비겼다면\n",
        "이후에는 (51/151,100/151) 의 확률로 (가위,바위) 중 하나를 선택한다.\n",
        "102번째 대결에 플레이어B가 바위를 내서 이겼다면 이후에는 각각\n",
        "(51/153,102/153) 의 확률로 (가위,바위) 중 하나를 선택한다. 이러한 상황을\n",
        "요약하여 표로 정리하면 아래와 같다.\n",
        "\n",
        "| 시점  | 플레이어B가 가위를 냈을 경우 얻은 점수 총합 | 플레이어B가 바위를 냈을 경우 얻은 점수 총합 | t+1시점에서 플레이어B가 (가위,바위)를 낼 확률 |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t=100 |                     50                      |                     100                     |               (50/150, 100/150)               |\n",
        "| t=101 |                     51                      |                     100                     |               (51/151, 100/151)               |\n",
        "| t=102 |                     51                      |                     102                     |               (51/153, 102/153)               |\n",
        "\n",
        "이러한 방식으로 500회까지 게임을 진행하며 확률을 수정하였을 경우 501번째\n",
        "대결에서 플레이어B가 (가위,바위)를 낼 확률은 각각 얼마인가?\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 시간이 지날수록 플레이어B는 (가위,바위)중 바위를 내는 쪽이\n",
        "> 유리하다는 것을 알게 될 것이다.**\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "앞으로 아래와 같은 용어를 사용한다.\n",
        "\n",
        "> **정의: 학습모드상태**\n",
        ">\n",
        "> 어떠한 플레이어가 양손 중 하나를 선택하는 확률을 데이터를 바탕으로 매\n",
        "> 순간 업데이트 한다면 그 플레이어는 ***“학습모드 상태이다”***라고\n",
        "> 표현한다. 반대로 어떠한 플레이어가 양손 중 하나를 항상 동일한 확률로\n",
        "> 낸다면 그 플레이어는 ***“학습모드 상태가 아니다”*** 라고 표현한다.\n",
        "\n",
        "------------------------------------------------------------------------\n",
        "\n",
        "`(4)` 새로운 두명의 플레이어C와 플레이어D를 만들어라. 두 플레이어는 모두\n",
        "동일하게 (가위,바위) 중 하나를 선택할 수 있다. 두 명의 플레이어는\n",
        "100번째 대결까지는 두 가지 패중 하나를 랜덤하게 선택하고 101번째\n",
        "대결부터 500번째 대결까지는 문제(3)의 플레이어B와 같은 방식으로 확률을\n",
        "업데이트 하여 두 가지 패를 서로 다른 확률로 낸다고 하자. 즉 100번째\n",
        "대결까지는 두 플레이어가 모두 학습모드 상태가 아니고 101번째부터 500번째\n",
        "대결까지는 두 플레이어가 모두 학습모드 상태이다. 500번째 대결까지의\n",
        "학습이 끝났을 경우 플레이어 C와 플레이어D가 각 패를 낼 확률은 각각\n",
        "얼마인가?\n",
        "\n",
        "|   시점    | 플레이어C가 (가위,바위)를 낼 확률  | 플레이어D가 (가위,바위)를 낼 확률  |                비고                |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t \\<= 100 |             (1/2, 1/2)             |             (1/2, 1/2)             | 양쪽 플레이어 모두 학습모드가 아님 |\n",
        "| t \\<= 500 | 대결 데이터를 학습하여 수정한 확률 | 대결 데이터를 학습하여 수정한 확률 |   양쪽 플레이어 모두 학습모드임    |\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 시간이 지날수록 두 플레이어 모두 바위를 내는 쪽이 유리하다는\n",
        "> 것을 알게 될 것이다.**\n",
        "\n",
        "`(5)` 새로운 플레이어 E와 F를 생각하자. 플레이어E와 플레이어F는 각각\n",
        "(가위,바위) 그리고 (가위,보) 중 하나를 선택할 수 있다고 가정하자.\n",
        "시뮬레이션 대결결과를 이용하여 아래의 확률을 근사적으로 추정하라.\n",
        "\n",
        "-   플레이어E가 승리할 확률:\n",
        "-   플레이어F가 승리할 확률:\n",
        "-   플레이어E와 플레이어F가 비길 확률:\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 플레이어E가 가위를 낸다면 최소한 지지는 않기 때문에\n",
        "> 플레이어E가 좀 더 유리한 패를 가지고 있다. 따라서 플레이어E의 결과가\n",
        "> 더 좋을 것이다.**\n",
        "\n",
        "`(6)` (5)와 동일한 두 명의 플레이어E, F를 생각하자. 두 플레이어는\n",
        "100회까지는 랜덤으로 자신의 패를 선택한다. 그리고 101회부터 500회까지는\n",
        "플레이어F만 데이터로 부터 학습을 하여 수정된 확률을 사용한다. 500번의\n",
        "대결이 끝나고 플레이어F가 (가위,보)를 선택하는 확률이 어떻게 업데이트\n",
        "되어있는가?\n",
        "\n",
        "|   시점    | 플레이어E가 (가위,바위)를 낼 확률 | 플레이어F가 (가위,보)를 낼 확률 |                      비고                       |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t \\<= 100 |            (1/2, 1/2)             |           (1/2, 1/2)            |       양쪽 플레이어 모두 학습모드가 아님        |\n",
        "| t \\<= 500 |            (1/2, 1/2)             |  데이터를 학습하여 수정한 확률  | 플레이어E는 학습모드아님 / 플레이어F는 학습모드 |\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 플레이어F는 보를 내는 것이 낫다고 생각할 것이다. (가위를 내면\n",
        "> 지거나 비기지만 보를 내면 지거나 이긴다.)**\n",
        "\n",
        "`(7)` (6)번의 플레이어E와 플레이어F가 500회~1000회까지 추가로 게임을\n",
        "한다. 이번에는 플레이어E만 데이터로부터 학습한다. 1000회까지 대결을 끝낸\n",
        "이후 플레이어E가 (가위,바위)를 내는 확률은 어떻게 업데이트 되었는가?\n",
        "\n",
        "|    시점    | 플레이어E가 (가위,바위)를 낼 확률 | 플레이어F가 (가위,보)를 낼 확률 |                      비고                       |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t \\<= 100  |            (1/2, 1/2)             |           (1/2, 1/2)            |       양쪽 플레이어 모두 학습모드가 아님        |\n",
        "| t \\<= 500  |            (1/2, 1/2)             |  데이터를 학습하여 수정한 확률  | 플레이어E는 학습모드아님 / 플레이어F는 학습모드 |\n",
        "| t \\<= 1000 |   데이터를 학습하여 수정한 확률   |   t=500시점에 업데이트된 확률   | 플레이어E는 학습모드 / 플레이어F는 학습모드아님 |\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 플레이어F는 보를 내도록 학습되어 있다. 따라서 플레이어E가\n",
        "> 바위를 내면 지고 가위를 내면 이길것이다. 따라서 플레이어E는 가위가\n",
        "> 유리하다고 생각할 것이다.**\n",
        "\n",
        "`(8)` (7)번의 플레이어E와 플레이어F가 1000회~30000회까지 추가로 게임을\n",
        "한다. 이번에는 플레이어F만 데이터로부터 학습한다. 30000회까지 대결을\n",
        "끝낸 이후 플레이어F가 (가위,보)를 내는 확률은 어떻게 업데이트 되었는가?\n",
        "\n",
        "|    시점     | 플레이어E가 (가위,바위)를 낼 확률 | 플레이어F가 (가위,보)를 낼 확률 |                      비고                       |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "|  t \\<= 100  |            (1/2, 1/2)             |           (1/2, 1/2)            |       양쪽 플레이어 모두 학습모드가 아님        |\n",
        "|  t \\<= 500  |            (1/2, 1/2)             |  데이터를 학습하여 수정한 확률  | 플레이어E는 학습모드아님 / 플레이어F는 학습모드 |\n",
        "| t \\<= 1000  |   데이터를 학습하여 수정한 확률   |   t=500시점에 업데이트된 확률   | 플레이어E는 학습모드 / 플레이어F는 학습모드아님 |\n",
        "| t \\<= 30000 |   t=1000시점에 업데이트된 확률    |  데이터를 학습하여 수정한 확률  | 플레이어E는 학습모드아님 / 플레이어F는 학습모드 |\n",
        "\n",
        "> **Note**\n",
        ">\n",
        "> **hint: 플레이어F는 원래 보가 유리하다고 생각하여 보를 자주 내도록\n",
        "> 학습되었다. 하지만 플레이어E가 그러한 플레이어F의 성향을 파악하고\n",
        "> 가위를 주로 내도록 학습하였다. 플레이어F는 그러한 플레이어E의 성향을\n",
        "> 다시 파악하여 이번에는 가위을 자주 내는 것이 유리하다고 생각할\n",
        "> 것이다.**\n",
        "\n",
        "`(9)` 플레이어E와 플레이어F의 대결기록을 초기화 한다. 이번에는\n",
        "플레이어F가 항상 (3/4)의 확률로 가위를 (1/4)의 확률로 보를 낸다고\n",
        "가정한다. 플레이어E는 100번의 대결까지는 랜덤으로 (가위,바위)중 하나를\n",
        "내고 101번째 대결부터 1000번째 대결까지는 대결 데이터를 학습하여 수정한\n",
        "확률을 사용한다고 하자. 1000번째 대결이후에 플레이어E가 (가위,바위)를\n",
        "내는 확률이 어떻게 업데이트 되어있는가?\n",
        "\n",
        "|    시점    | 플레이어E가 (가위,바위)를 낼 확률 | 플레이어F가 (가위,보)를 낼 확률 |                       비고                       |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t \\<= 100  |            (1/2, 1/2)             |           (3/4, 1/4)            |        양쪽 플레이어 모두 학습모드가 아님        |\n",
        "| t \\<= 1000 |   데이터를 학습하여 수정한 확률   |           (3/4, 1/4)            | 플레이어E는 학습모드 / 플레이어F는 학습모드 아님 |\n",
        "\n",
        "`(10)` 플레이어E와 플레이어F의 대결기록을 초기화 한다. 이번에는\n",
        "플레이어F가 항상 (2/3)의 확률로 가위를 (1/3)의 확률로 보를 낸다고\n",
        "가정한다. 플레이어E는 100번의 대결까지는 랜덤으로 (가위,바위)중 하나를\n",
        "내고 101번째 대결부터 1000번째 대결까지는 대결 데이터를 학습하여 수정한\n",
        "확률을 사용한다고 하자. 1000번째 대결이후에 플레이어E가 (가위,바위)를\n",
        "내는 확률이 어떻게 업데이트 되어있는가?\n",
        "\n",
        "|    시점    | 플레이어E가 (가위,바위)를 낼 확률 | 플레이어F가 (가위,보)를 낼 확률 |                       비고                       |\n",
        "|:----------------:|:----------------:|:----------------:|:----------------:|\n",
        "| t \\<= 100  |            (1/2, 1/2)             |           (2/3, 1/3)            |        양쪽 플레이어 모두 학습모드가 아님        |\n",
        "| t \\<= 1000 |   데이터를 학습하여 수정한 확률   |           (2/3, 1/3)            | 플레이어E는 학습모드 / 플레이어F는 학습모드 아님 |"
      ],
      "id": "8dee682d-51df-4bd9-a3da-991406116975"
    }
  ],
  "nbformat": 4,
  "nbformat_minor": 5,
  "metadata": {
    "kernelspec": {
      "name": "python3",
      "display_name": "Python 3",
      "language": "python"
    },
    "language_info": {
      "name": "python",
      "codemirror_mode": {
        "name": "ipython",
        "version": "3"
      },
      "file_extension": ".py",
      "mimetype": "text/x-python",
      "nbconvert_exporter": "python",
      "pygments_lexer": "ipython3",
      "version": "3.8.16"
    }
  }
}